// declarative fields

// -------------УСЛОВИЕ-------------
// Как известно, элемент массива и объекта может быть любого типа данных JS, т.е.в коде может быть любое выражение,
// которое вычисляется в то или иное значение типа данных.
// А значит, мы можем применять функции для ввода данных типа confirm или prompt:
// var text = "Enter a number";
// var arr3 = [+prompt(text), +prompt(text), +prompt(text)]; //вводим числа.
// Организуйте таким способом заполнение полей в объектах:
var notebook = {
    brand: "HP",
    type:  "440 G4",
    model: "Y7Z75EA",
    ram: 4,
    size: "14",
    weight: 1.8,
    resolution: {
        width: 1920,
        height: 1080,
    },
};

var phone = {
    brand: "meizu",
    model: "m2",
    ram: 2,
    color: "black",
};

var person = {
    name: "Donald",
    surname: "Trump",
    married: true,
}
// Например:
// var person = {
//     name: prompt("Enter a name"),
//     surname: prompt("Enter a surname"),
// }
// Используйте приведение к числу, prompt и confirm в зависимости от типов данных.

// -------------РЕШЕНИЕ-------------

const task02block = document.createElement('div');
task02block.style = "border: 2px solid green; border-radius:5px; margin-bottom:10px; padding:10px";
const task02title = document.createElement('h2');
task02title.innerText = 'Task-02 Declarative fields';
const inputBtn = document.createElement('button');
inputBtn.innerText = 'Start input data';
inputBtn.style = 'margin-bottom:10px';
root.appendChild(task02block); 
task02block.appendChild(task02title); 
task02block.appendChild(inputBtn); 

inputBtn.onclick = () => {
const good1 = document.createElement('div');
const good2 = document.createElement('div');
const good3 = document.createElement('div');
    let notebookNew = {
        brand: prompt("Notebook: enter a brand"),
        type: prompt("Notebook: enter a type"),
        model: prompt("Notebook: enter a model"),
        ram: +prompt("Notebook: enter ram number"),
        size: prompt("Notebook: enter a size"),
        weight: +prompt("Notebook: enter a weight"),
        resolution: {
            width: +prompt("Notebook: enter width"),
            height: +prompt("Notebook: enter height"),
        },
        
    };
    good1.innerText = "Notebook:"+JSON.stringify(notebookNew);
    task02block.appendChild(good1); 
    console.log(notebookNew);
    
    var phoneNew = {
        brand: prompt("Phone: enter a brand"),
        model: prompt("Phone: enter a model"),
        ram: +prompt("Phone: enter ram"),
        color: prompt("Phone: enter a color"),
    };
    good2.innerText = "Phone:"+JSON.stringify(phoneNew);
    task02block.appendChild(good2); 
    console.log(phoneNew);

    var personNew = {
        name: prompt("Person: enter a name"),
        surname: prompt("Person: enter a surname"),
        married: confirm("Person: es married?"),
    }
    good3.innerText = "Person:"+JSON.stringify(personNew);
    task02block.appendChild(good3); 
    console.log(personNew);
}